package com.rbevans;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author evansrb1
 */
public class Database {

	private final static String url="jdbc:mysql://localhost:3306/";
	private final static String driver = "com.mysql.jdbc.Driver";
	private final static String user = "en605681Test";
	private final static String pass = "L3tMeIn!";
	private final static String db="en605681";
	// Note: only use the options for MySQL drivers version 8 or greater, do not use them with web7 connections
	private final static String options="?useSSL=false";
	
	public Database() {
	}
	
	private void dropTables(Connection conn) {
		try (Statement statement = conn.createStatement()) {
			System.out.println("Database: dropping table People...");
			statement.executeUpdate("drop table People");
		} catch (SQLException ex) {
			Logger.getLogger(Database.class.getName()).log(Level.SEVERE, null, ex);
		}
	}
	
	private void initializeDatabase() throws SQLException {
		try (Connection conn = DriverManager.getConnection(url + db + options, user, pass);
				Statement statement = conn.createStatement()) {
			dropTables(conn);
			
			conn.setAutoCommit(false);
			// create a batch statement and add SQL commands to it
			statement.addBatch("create table PEOPLE (PERSON int, FIRST_NAME varchar(20), LAST_NAME varchar(20), ADDRESS varchar(20), CITY varchar(20), STATE varchar(2), ZIP int)");
			statement.addBatch("insert into PEOPLE values(1, 'Bob', 'Evans', '123 Beartooth Hwy', 'Cooke City', 'WY', 12345)");
			statement.addBatch("insert into PEOPLE values(2, 'Tom', 'Smith', '11100 Johns Hopkins', 'Laurel', 'MD', 20723)");
			statement.addBatch("insert into PEOPLE values(3, 'John', 'Doe', '15682 Port Dr', 'Garden Grove', 'CA', 92643)");
			statement.addBatch("insert into PEOPLE values(4, 'Mickey', 'Mouse', '33 Royal Street', 'Anaheim', 'CA', 92802)");
			statement.addBatch("insert into PEOPLE values(5, 'Walter', 'Knott', '8039 Beach Blvd', 'Buena Park', 'CA', 90620)");
			statement.addBatch("insert into PEOPLE values(6, 'John', 'Wayne', '18601 Airport Way', 'Santa Ana', 'CA', 92707)");
			statement.addBatch("create table CAMERAS (CAMERA int, MFG varchar(20), Model varchar(20), PERSON int)");
			statement.addBatch("insert into CAMERAS values (1, 'Canon', '60D', 1)");
			statement.addBatch("insert into CAMERAS values (2, 'Canon', '70D', 5)");
			statement.addBatch("insert into CAMERAS values (3, 'Nikon', 'D70', 4)");
			
			// submits a batch of commands to the database for execution
			int[] updateCounts = statement.executeBatch();
			
			// Makes all changes made since the previous commit/rollback permanent
			// and releases any database locks currently held by this Connection object. 
			// This method should be used only when auto-commit mode has been disabled.
			System.out.print("Database: rebuilding tables...");
			conn.commit();
			
			// Sets this connection's auto-commit mode to true. If a connection 
			// is in auto-commit mode, then all its SQL statements will be executed and 
			// committed as individual transactions. Otherwise, its SQL statements are 
			// grouped into transactions that are terminated by a call to either the method 
			// commit or the method rollback. By default, new connections are in auto-commit mode.
			conn.setAutoCommit(true);
			System.out.println("...rebuilt!");
		 } catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
		 }
	}
		
}
